SystemOrganization addCategory: #'Rizel-Roassal-Views'!
SystemOrganization addCategory: #'Rizel-Roassal-Views-Tests'!

TestCase subclass: #RzVisualizer1DTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views-Tests'!

!RzVisualizer1DTest commentStamp: '<historical>' prior: 0!
A RzVisualizer1DTest is a test class for testing the behavior of RzVisualizer1D!

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:04'!
tearDown 
	""
	window ifNotNilDo: [ :w | w delete].! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:23'!
testBarWidth
	"
	self new testBarWidth
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			barWidth: 20;
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:21'!
testBasic
	"
	self new testBasic
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 18:12'!
testBasic2
	"
	self new testBasic2
	"
	window := RzVisualizer1D new 
			values: #( 10 67 120 1230 1250);
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:23'!
testGap
	"
	self new testGap
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			gap: 40;
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:23'!
testHeight
	"
	self new testHeight
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			height: 300;
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:23'!
testLabel
	"
	self new testLabel
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			label: [ :model | 'x'];
			visualize.! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:21'!
testOwner
	"
	self new testPadding
	"
	|viz|
	viz  := RzVisualizer1D owner: 3.
	window := viz
				values: #( 10 20 30 40 10);
				padding: 100;
				visualize.
				
	self assert: (viz owner = 3).! !

!RzVisualizer1DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:19'!
testPadding
	"
	self new testPadding
	"
	window := RzVisualizer1D new 
			values: #( 10 20 30 40 10);
			padding: 100;
			visualize.! !

TestCase subclass: #RzVisualizer2DTest
	instanceVariableNames: 'resultSet xs ys window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views-Tests'!

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:04'!
tearDown
	window ifNotNilDo: [:w| w delete.]! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:30'!
testBasic
	"
	self new testBasic
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x+y ];
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:03'!
testColor
	"
	self new testColor
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						color: Color blue;
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:03'!
testFactor
	"
	self new testFactor
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						factor: 50;
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:02'!
testGap
	"
	self new testGap
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						gap: 50;
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:11'!
testLabels
	"
	self new testLabels
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						padding: 100;
						yLabel:[ :number| 'long long text'];
						xLabel:[ :number| 'text'];
						visualize.! !

!RzVisualizer2DTest methodsFor: 'testing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:00'!
testPadding
	"
	self new testPadding
	"
	window := RzVisualizer2D new
						xValues: #(1 2 3);
						yValues: #(1 2 3);
						value: [ :x :y | x//y ];
						padding: 100;
						yLabel:[ :number| 'long long text'];
						visualize.! !

Object subclass: #RzRect
	instanceVariableNames: 'x y width height color model last borderColor text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzRect methodsFor: 'comparing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:17'!
= aRzDummy 
	^ model = aRzDummy model! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 16:33'!
borderColor
	^ borderColor! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 21:34'!
borderColor: aColor
	borderColor := aColor.! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 21:33'!
color
	^ color! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 21:33'!
color: aColor
	color := aColor.! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
hasLast
	^ last notNil! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
height
	^ height! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
height: anInteger 
	height := anInteger! !

!RzRect methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 16:35'!
initialize 
	super initialize.
	text := [ :m | m asString].
	x := 0.
	y := 0.
	width := 5.
	height := 5.
	model := ''.
	color := Color white.
	borderColor := Color black.
	
	! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
last
	^ last! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
last: anObject 
	last := anObject! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
model
	^ model! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
model: anObject
	model := anObject! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:08'!
printOn: aStream
	"delegate resposability"
	aStream nextPutAll: (text value: model).
	! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:03'!
printString
	
	^ text value: model.! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:03'!
text
	^ text! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:03'!
text: aBlock
	text := aBlock.! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
width
	^ width! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
width: anInteger 
	width := anInteger! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
x
	^ x! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
x: anInteger 
	x := anInteger! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
y
	^ y! !

!RzRect methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 23:16'!
y: anInteger
	y := anInteger! !

Object subclass: #RzVisualizer
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer class methodsFor: 'factory' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 16:20'!
owner: object 
	| inst |
	inst := self new.
	inst owner: object.
	^ inst.! !

!RzVisualizer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 21:25'!
applyLayoutIn: view
	view scatterPlotLayout 
			x:#x;
			y:#y.
	! !

!RzVisualizer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 21:26'!
draw: rzDummy in: view
	""
	self draw: rzDummy  in: view  forIt:[]. ! !

!RzVisualizer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 16:35'!
draw: rzDummy in: view forIt: aBlock
	view shape rectangle 
					width: rzDummy width;
					height: rzDummy height;
					fillColor: rzDummy color;
					borderColor: rzDummy borderColor.
	view node: rzDummy forIt: aBlock.! !

!RzVisualizer methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 21:59'!
drawLabel: aString at:aPoint in: view
	""
	view label text: [:model | aString].
	view node: (RzRect new
					x: aPoint x;
					y: aPoint y).! !

!RzVisualizer methodsFor: 'as yet unclassified' stamp: ''!
owner
	^ owner! !

!RzVisualizer methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 16:19'!
owner: object
	owner := object! !

!RzVisualizer methodsFor: 'visualization' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:17'!
visualize
	"open a window"
	| view |
	view := ROMondrianViewBuilder new.
	self visualizeOn: view.
	^ view open.! !

RzVisualizer subclass: #RzVisualizer1D
	instanceVariableNames: 'label gap values padding height barWidth factor y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:13'!
barWidth: aNumber
	barWidth := aNumber! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 16:17'!
gap: aNumber
	gap := aNumber! !

!RzVisualizer1D methodsFor: 'accessing' stamp: ''!
height
	^ height! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 16:17'!
height: aNumber 
	height := aNumber! !

!RzVisualizer1D methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 21:49'!
initialize
	super initialize.
	factor := 2.
	gap := 40.
	padding := 50.
	height := 200.
	label := [:model | model printString].
	barWidth := 10.
	y := [ :model| model].! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 16:18'!
label: aString
	label := aString! !

!RzVisualizer1D methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 21:46'!
minValue: aBlock in: aCollection
	|min|
	min := aCollection maxValue: aBlock.
	values do:[ :model|
		min := (aBlock value:model) min: min. ].
	^ min.! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 16:18'!
padding: aNumber
	padding := aNumber! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 16:18'!
values: aCollection
	values := aCollection! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 18:16'!
visualizeBarsOn: view
	"visualizing values"
	|min max diff delta xo|
	min := self minValue: y in: values.
	max := values maxValue: y.
	diff := max - min.
	delta := (max = min) ifTrue:[ self height ] ifFalse:[ self height / diff].
	xo := gap.
	values do:[ :model |
		|val|
		val := y value: model.
		self draw: (RzRect new
						x: xo;
						y: ((self height - ((val - min)*delta)) asInteger);
						model: model;
						color: Color blue;
						width: barWidth;
						height: (((val - min)* delta)) asInteger)
			 in: view.
		self drawLabel: (label value: model)
		 	 at:  (xo@(self height + 10))
			 in: view.
		xo := xo + (barWidth + gap)].
	self applyLayoutIn: view.! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 16:17'!
visualizeOn: view
	"roassal scripts"
	self visualizeValuesOn: view.
	self applyLayoutIn: view.! !

!RzVisualizer1D methodsFor: 'drawing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 16:33'!
visualizeValuesOn: view
	"visualizing values"
	self draw: (RzRect new
					x: (padding + factor + gap);
					y: (factor + gap);
					width: (self width);
					borderColor: Color white;
					height: (self height))
		 in: view 
		 forIt: [self visualizeBarsOn: view ].
	self applyLayoutIn: view.
	! !

!RzVisualizer1D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 21:31'!
width
	^  (factor + (gap + barWidth) * values size).! !

RzVisualizer subclass: #RzVisualizer2D
	instanceVariableNames: 'xValues yValues factor gap value padding xLabel yLabel color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:01'!
color: aColor
	color := aColor.! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:42'!
factor: aNumber
	factor := aNumber! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:42'!
gap: aNumber
	gap := aNumber! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:42'!
height
	^ yValues size * (factor + gap).! !

!RzVisualizer2D methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 17:02'!
initialize
	super initialize.
	gap := 20.
	factor := 25.
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	padding := 50.
	color := Color red.
	xLabel := [ :m | m printString].
	yLabel := [ :m | m printString].! !

!RzVisualizer2D methodsFor: 'util' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 16:45'!
max
	|max|
	max := 0.
	xValues do:[ :x | yValues do:[ :y |
			(value value:x value: y) ifNotNilDo: [:val|
				max := val max: max.]. ]].
	^ max.
	
! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:43'!
padding: aNumber
	padding := aNumber! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:43'!
value: aBlock
	value := aBlock! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 16:14'!
visualizeOn: view 
	"visualizing"
	self visualizeValuesOn: view.
	self visualizeXAxisOn: view.
	self visualizeYAxisOn: view.
	view scatterPlotLayout x: #x; y: #y.! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 15:06'!
visualizePointsOn: view
	|xo yo colors|
	colors := Color white mix: color shades: 101.
	yo := gap//2.
	yValues do: [ :y |
		|max|
		max :=  (xValues collect: [ :x | value value:x value:y]) maxValue:#yourself.
		xo := gap //2.
		xValues do:[ :x|
			|model|
			model := (value value: x value: y).
			model ifNil:[ model:=0].
			self draw: (RzRect new
							x: xo;
							y: yo;
							model: model;
							color: (colors at: ((model* 100 / max+1) asInteger));
							width: factor;
							height: factor)
				in: view.	
			xo := xo + factor + gap.].	
	yo := yo + factor + gap.].
	self applyLayoutIn: view.! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 16:05'!
visualizeValuesOn: view 
	
	self draw: (RzRect new
						x:  (padding + gap);
						y:  gap;
						width: (self height);
						height: (self width)) 
		 in: view  
		 forIt:[ self visualizePointsOn: view ]. ! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 7/7/2012 16:56'!
visualizeXAxisOn: view
	"visualizing x axis"
	| yo xo |
	xo := padding + gap +  (gap //2).
	yo := gap + (self height) + (gap//2).
	
	xValues do:[ :model |
		self drawLabel: (xLabel value: model)
			 at:  (xo@yo)
			 in: view.
		xo := xo + (factor + gap).].! !

!RzVisualizer2D methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 15:09'!
visualizeYAxisOn: view
	"visualizing y axis"
	| yo xo |
	xo := gap.
	yo := gap + (gap//2).
	
	yValues do:[ :model |
		self drawLabel: (yLabel value: model)
			 at:  (xo@yo)
			 in: view.
		yo := yo + (factor + gap).].! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/6/2012 22:42'!
width
	^ xValues size * (factor + gap).! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:43'!
xLabel: aBlock
	xLabel := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:43'!
xValues: aBlock 
	xValues := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:44'!
yLabel: aBlock 
	yLabel := aBlock! !

!RzVisualizer2D methodsFor: 'accessing' stamp: 'JuanPabloSandovala 6/1/2012 14:44'!
yValues: aBlock
	yValues := aBlock! !

RzVisualizer subclass: #RzVisualizerMerge
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizerMerge class methodsFor: 'factory' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 18:37'!
on: profile
	|inst|
	inst := self new.
	inst profile: profile.
	^ inst.! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 18:57'!
borderColorForMethod: rzMethod
	""
	(rzMethod hasDifferentByteCode) ifTrue:[ ^ Color red].
	^ Color gray.
	! !

!RzVisualizerMerge methodsFor: 'morph' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 23:29'!
browseMethod: m
	"
	((DiffMorph from: 'aaabba' to:'b') extent:(200@200)) newWindow open
	"
	|oldSourceCode newSourceCode|
	oldSourceCode := m property:#copySourceCode  from: #old  ifAbsent: ['']. 
	newSourceCode := m property:#copySourceCode  from: #new  ifAbsent: ['']. 
	
	((DiffMorph from: oldSourceCode to:newSourceCode) extent:(200@200)) newWindow open! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 22:34'!
colorForMethod: rzMethod
	|before after|
	before := rzMethod property:#executionTime from:#old ifAbsent:[ 0 ] .
	after := rzMethod property:#executionTime from:#new ifAbsent:[ 0 ].
	
	(rzMethod wasDeleted ) ifTrue: [ ^ Color gray].
	(rzMethod isNew) ifTrue:[ ^ Color yellow].
	(after > before) ifTrue: [ ^ Color red].
	(after < before) ifTrue: [ ^ Color green].
	
	^ Color white.
	! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 23:18'!
heightForMethod: rzMethod
	|before after|
	before := rzMethod property:#executionTime from:#old ifAbsent:[ 0 ] .
	after := rzMethod property:#executionTime from:#new ifAbsent:[ 0 ].
	Transcript show: (before asString),' - ',(after asString);cr.
	^ ((after > before) ifTrue:[ after - before] ifFalse:[ 0 ]) +5.! !

!RzVisualizerMerge methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 18:36'!
profile
	^ profile.! !

!RzVisualizerMerge methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 18:36'!
profile: rzProfile
	""
	profile := rzProfile.! !

!RzVisualizerMerge methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 7/8/2012 23:19'!
visualizeClasses: package in: view.
	
	view shape rectangle withoutBorder.
	view nodes: (package classes select:[ :cls|  ('* class' match:(cls className)) not]) forEach:[ :cls|
			view node:'methods' forIt:[ self visualizeMethods:cls in: view].
			view shape label.
			view node: (cls className).
			view verticalLineLayout.
		].
	view horizontalLineLayout.! !

!RzVisualizerMerge methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 23:30'!
visualizeMethods: cls in: view.
	""
	view shape rectangle
					width: [ :m |  (self widthForMethod: m)];
					height: [ :m|  (self heightForMethod: m) ];
					color: [ :m  |  self colorForMethod:m];
					borderColor: [ :m |  self borderColorForMethod:m].
	view interaction 
		item: 'browse code' action: [:m | self browseMethod: m.].
	view nodes: (cls allMethods).
	view edges: (cls allMethods) from: #yourself toAll:[ :m |m callingMethods].
	view treeLayout.! !

!RzVisualizerMerge methodsFor: 'roassal' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 20:45'!
visualizeOn: view
	""
	"view shape rectangle withoutBorder.
	view nodes: (profile packages) forEach: [ :package |
			view node:'classes' forIt:[ self visualizeClasses: package in: view].
			view shape label.
			view node: (package packageName).
			view verticalLineLayout.
		].
	view horizontalLineLayout."
	self visualizeMethods: profile  in: view.
	! !

!RzVisualizerMerge methodsFor: 'metrics' stamp: 'JuanPabloSandovalAlcocer 7/9/2012 23:18'!
widthForMethod: rzMethod
	|before after|
	before := rzMethod property:#numberOfExecutions from:#old ifAbsent:[ 0 ] .
	after := rzMethod property:#numberOfExecutions from:#new ifAbsent:[ 0 ].
	^ ((after > before) ifTrue:[ after - before] ifFalse:[ 0 ]) + 5.! !

Object subclass: #RzVisualizerSelector
	instanceVariableNames: 'owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Roassal-Views'!

!RzVisualizerSelector class methodsFor: 'as yet unclassified' stamp: ''!
owner: t1 
	| t2 |
	t2 := self new.
	t2 owner: t1.
	^ t2! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: ''!
owner
	^ owner! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovala 6/1/2012 14:47'!
owner: rizelBuilder
	owner := rizelBuilder! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovala 6/1/2012 14:47'!
v1D
	| rzv |
	rzv := RzVisualizer1D owner: owner.
	owner visualizer: rzv.
	^ rzv! !

!RzVisualizerSelector methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovala 6/1/2012 14:47'!
v2D
	| rzv |
	rzv := RzVisualizer2D owner: owner.
	owner visualizer: rzv.
	^ rzv! !
